BuildRequires: /proc
BuildRequires: jpackage-compat
%define version 5
%define name maven-release
# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#


# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define bname release
%define manager_version 1.0-alpha-5
%define plugin_version 2.0-beta-8

%define maven_settings_file %{_builddir}/%{name}/settings.xml

Name:           maven-release
Version:        5
Release:        alt2_2jpp6
Epoch:          0
Summary:        Maven Release
License:        Apache Software License 2.0
Group:          Development/Java
URL:            http://maven.apache.org/
Source0:        %{name}-%{version}.tar.gz
# svn export http://svn.apache.org/repos/asf/maven/release/tags/maven-release-5/


Source1:        %{name}-%{version}-build.xml
Source2:        %{name}-%{version}-jpp-depmap.xml
Source3:        %{name}-%{version}-settings.xml
Source4:        %{name}-%{version}-autogenerated-files.tar.gz
Patch0:         %{name}-%{version}-InvokerMavenExecutor.patch
Patch1:         %{name}-%{version}-ForkedMavenExecutorTest.patch
Patch2:         %{name}-%{version}-plugin-pom.patch
Patch3:         %{name}-manager-pom.patch


BuildArch:      noarch
BuildRequires: jpackage-utils >= 0:1.7.5
BuildRequires: ant >= 0:1.7.1
%if %{with_maven}
BuildRequires: maven2-common-poms
BuildRequires: maven2 >= 0:2.0.8
BuildRequires: maven2-plugin-ant
BuildRequires: maven2-plugin-antrun
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-plugin
BuildRequires: maven2-plugin-resources
BuildRequires: maven-surefire-plugin
BuildRequires: modello-maven-plugin >= 0:1.0-0.a15.2
BuildRequires: apache-commons-parent
BuildRequires: plexus-maven-plugin >= 0:1.3.5
%endif
BuildRequires: geronimo-jta-1.0.1B-api
BuildRequires: jaxen
BuildRequires: jdom
BuildRequires: jmock
BuildRequires: maven2 >= 0:2.0.8
BuildRequires: maven-scm >= 0:1.1
BuildRequires: maven-scm-test >= 0:1.1
BuildRequires: maven-shared-plugin-testing-harness
BuildRequires: maven-wagon
BuildRequires: modello >= 0:1.3
BuildRequires: plexus-container-default
BuildRequires: plexus-interactivity
BuildRequires: plexus-utils

Requires: jaxen
Requires: jdom
Requires: maven2 >= 0:2.0.8
Requires: maven-scm >= 0:1.1
Requires: plexus-container-default
Requires: plexus-interactivity
Requires: plexus-utils

Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
Provides:  maven2-plugin-release = %{epoch}:%{version}-%{release}
Obsoletes: maven2-plugin-release < %{epoch}:2.0.5
Source44: import.info
BuildRequires: cglib
Provides: maven2-plugin-release = 2.0.7

%description
Maven Release.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildArch: noarch

%description javadoc
%{summary}.

%prep
%setup -q 
cp %{SOURCE1} build.xml
cp %{SOURCE3} settings.xml
gzip -dc %{SOURCE4} | tar xf -
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3

%build
%if %{with_maven}
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2_SETTINGS=$(pwd)/settings.xml
mvn-jpp -Dmaven.compile.target=1.5 -Dmaven.javadoc.source=1.5  \
        -e \
        -s $M2_SETTINGS \
        -Dmaven.test.failure.ignore=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        ant:ant install
mvn-jpp -Dmaven.compile.target=1.5 -Dmaven.javadoc.source=1.5  \
        -e \
        -s $M2_SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        javadoc:javadoc
%else
export CLASSPATH=$(build-classpath \
modello/core \
modello/plugin-xml \
modello/plugin-xpp3 \
plexus/classworlds classworlds \
plexus/containers-component-api \
plexus/containers-container-default \
plexus/utils \
)

pushd maven-release-manager
java org.codehaus.modello.ModelloCli src/main/mdo/release-descriptor.mdo xpp3-reader src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/release-descriptor.mdo java src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/release-descriptor.mdo xpp3-writer src/main/java 1.0.0 false
popd

export CLASSPATH=$(build-classpath \
cglib-nodep \
classworlds \
jaxen \
jdom \
jmock \
jmock-cglib \
maven2/artifact \
maven2/artifact-manager \
maven2/core \
maven2/model \
maven2/plugin-api \
maven2/plugin-descriptor \
maven2/profile \
maven2/project \
maven2/settings \
maven-scm \
maven-shared/plugin-testing-harness \
maven-wagon/provider-api \
plexus/container-default \
plexus/interactivity-api \
plexus/utils \
)
CLASSPATH=$CLASSPATH:target/classes:target/test-classes
CLASSPATH=$CLASSPATH:src/test/resources
pushd maven-release-manager
ant -Dant.build.javac.source=1.5 -Dant.build.javac.target=1.5  -Dmaven.settings.offline=true -Dbuild.sysclasspath=only jar javadoc
popd
CLASSPATH=$CLASSPATH:$(pwd)/maven-release-manager/target/maven-release-manager-%{manager_version}.jar
pushd maven-release-plugin
mkdir -p target/classes/META-INF/maven/org.apache.maven.plugins/maven-release-plugin
cp pom.xml target/classes/META-INF/maven/org.apache.maven.plugins/maven-release-plugin
cat > target/classes/META-INF/maven/org.apache.maven.plugins/maven-release-plugin/pom.properties <<EOT
version=%{plugin_version}
groupId=org.apache.maven.plugins
artifactId=maven-release-plugin
EOT
ant -Dant.build.javac.source=1.5 -Dant.build.javac.target=1.5  -Dmaven.settings.offline=true -Dbuild.sysclasspath=only jar javadoc
popd
%endif

%install
# jars/poms
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/plugins

%add_to_maven_depmap org.apache.maven.release %{name} %{version} JPP/maven-release parent
install -pm 644 pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.maven-release-parent.pom

install -m 644 %{name}-manager/target/%{name}-manager-%{manager_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/manager-%{manager_version}.jar
%add_to_maven_depmap org.apache.maven.release %{name}-manager %{manager_version} JPP/%{name} manager
install -pm 644 %{name}-manager/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.%{name}-manager.pom

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{manager_version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{manager_version}||g"`; done)

install -m 644 %{name}-plugin/target/%{name}-plugin-%{plugin_version}.jar \
    $RPM_BUILD_ROOT%{_datadir}/maven2/plugins/release-plugin-%{plugin_version}.jar
%add_to_maven_depmap org.apache.maven.plugins %{name}-plugin %{plugin_version} JPP/maven2/plugins release-plugin
install -m 644 %{name}-plugin/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.maven2.plugins-release-plugin.pom
(cd $RPM_BUILD_ROOT%{_datadir}/maven2/plugins && for jar in *-%{plugin_version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{plugin_version}||g"`; done)


# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/manager
cp -pr %{name}-manager/target/site/apidocs/* \
                    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/manager
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugin
cp -pr %{name}-plugin/target/site/apidocs/* \
                    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugin
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%files
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_datadir}/maven2/plugins/*
%{_mavendepmapfragdir}/*

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Wed Feb 02 2011 Igor Vlasenko <viy@altlinux.ru> 0:5-alt2_2jpp6
- fixed requires on modello plugin

* Mon Jan 31 2011 Igor Vlasenko <viy@altlinux.ru> 0:5-alt1_2jpp6
- new version

* Thu Jan 27 2011 Igor Vlasenko <viy@altlinux.ru> 0:4-alt7_2jpp5
- fixed build

* Sun Jan 09 2011 Igor Vlasenko <viy@altlinux.ru> 0:4-alt6_2jpp5
- fixed build

* Tue Oct 26 2010 Igor Vlasenko <viy@altlinux.ru> 0:4-alt5_2jpp5
- fixed build with new maven 2.0.8

* Mon May 17 2010 Igor Vlasenko <viy@altlinux.ru> 0:4-alt4_2jpp5
- fixed plexus components

* Wed May 12 2010 Igor Vlasenko <viy@altlinux.ru> 0:4-alt3_2jpp5
- fixes for java6 support

* Fri Feb 27 2009 Igor Vlasenko <viy@altlinux.ru> 0:4-alt2_2jpp5
- fixed build

* Sat Jan 31 2009 Igor Vlasenko <viy@altlinux.ru> 0:4-alt1_2jpp5
- new version

